unit WndLoadSettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, DateUtils;

type
  TWndLoadSettings = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label3: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    FileName: TEdit;
    Label4: TLabel;
    secCount: TLabel;
    SpeedButton1: TSpeedButton;
    stab: TCheckBox;
    IMU: TCheckBox;
    gyro: TCheckBox;
    mag: TCheckBox;
    osd: TCheckBox;
    wp: TCheckBox;
    adc: TCheckBox;
    bat: TCheckBox;
    control_in: TCheckBox;
    control_out: TCheckBox;
    control_mix: TCheckBox;
    OpenDialog1: TOpenDialog;
    Pannel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure WaitForOk;
  end;

var
  WndLoadSettings: TWndLoadSettings;

implementation

uses MAIN;

{$R *.dfm}

procedure TWndLoadSettings.FormCreate(Sender: TObject);
begin
//
end;

procedure TWndLoadSettings.FormDestroy(Sender: TObject);
begin
  WndLoadSettings := nil;
end;

procedure TWndLoadSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TWndLoadSettings.BitBtn1Click(Sender: TObject);
var
  s,k,v,sn: string;
  i,p: integer;
  f: TStringList;
  cb: TCheckBox;
begin
  if (Length(FileName.Text)>0) and (FileExists(FileName.Text)) then begin
    f:= TStringlist.Create;
    f.LoadFromFile(FileName.Text);
    try
      secCount.Caption:='0';
      secCount.Visible:=true;
      Label4.Visible:=true;
      i:=1;
      MainForm.ClearInput;
      cb:=nil;
      while f.Count>0 do begin
        Application.ProcessMessages;
        s:=Trim(f[0]);
        f.Delete(0);
        if s='' then continue;
        if pos('##### BEGIN',s)>0 then begin
          if Pos('STAB ',s)>0 then cb:=stab;
          if Pos('IMU ',s)>0 then cb:=imu;
          if Pos('OSD ',s)>0 then cb:=osd;
          if Pos('GYRO ',s)>0 then cb:=gyro;
          if Pos('MAG ',s)>0 then cb:=mag;
          if Pos('WP ',s)>0 then cb:=wp;
          if Pos('ADC_SETTINGS ',s)>0 then cb:=adc;
          if Pos('BATTERIES ',s)>0 then cb:=bat;
          if Pos('CONTROL IN ',s)>0 then cb:=control_in;
          if Pos('CONTROL OUT ',s)>0 then cb:=control_out;
          if Pos('CONTROL MIXERS ',s)>0 then cb:=control_mix;

          s:='';
        end else
        if pos('##### END',s)>0 then begin
          cb:=nil;
          s:='';
        end;
        if (s<>'') and (cb<>nil) then begin
          if cb.Checked then begin
            i:=i+1;
            secCount.Caption:=IntToStr(i);
            s:=s+#13#10;
            MainForm.AddToOutput(s);
            WaitForOk;
          end;
        end;

      end;

    finally
      f.Free;
    end;
    secCount.Visible:=false;
    Label4.Visible:=false;
    Application.ProcessMessages;
    ShowMessage('  ');
  end else begin
     ShowMessage('    ');
  end;

end;

procedure TWndLoadSettings.SpeedButton1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    FileName.Text:= OpenDialog1.FileName;
  end;
end;

procedure TWndLoadSettings.WaitForOk;
var
   s: string;
   ts: TDateTime;
begin
   ts:=now;
      while true do begin
        if MilliSecondsBetween(Now,ts) > 1000 then break;
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
        end;
      end;

end;

procedure TWndLoadSettings.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

end.
